/*
 * Egis Technology Inc. (aka. LighTuning) 0575 driver for libfprint
 * Copyright (C) 2021 Animesh Sahu <animeshsahu19@yahoo.com>
 * Copyright (C) 2022 Nils Schötteler <schoetni1@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#pragma once

/*
 * Device data
 */

#define EGIS0575_CONFIGURATION 1
#define EGIS0575_INTERFACE 0

/*
 * Device endpoints
 */

#define EGIS0575_EPOUT 0x01 /* ( 1 | FPI_USB_ENDPOINT_OUT ) */
#define EGIS0575_EPIN 0x82  /* ( 2 | FPI_USB_ENDPOINT_IN ) */


#define EGIS0575_IMGWIDTH 103
#define EGIS0575_IMGHEIGHT 52
#define EGIS0575_IMGSIZE (EGIS0575_IMGWIDTH * EGIS0575_IMGHEIGHT)

#define EGIS0575_BZ3_THRESHOLD 15
#define EGIS0575_RFMGHEIGHT 45 // how much we cut from the top and bottom
#define EGIS0575_RFMDIS (EGIS0575_IMGHEIGHT - EGIS0575_RFMGHEIGHT) / 2
#define EGIS0575_RESIZE 1

/* MIN SD not the standard deviation anymore, other algorithm produced better distinction for me. without finger 25 to 125, with finger 100 to 300*/
#define EGIS0575_MIN_SD 125
#define EGIS0575_MAX_SD 525
#define EGIS0575_TIMEOUT 10000

// with 10 frames it takes a really long swipe to get an image
#define EGIS0575_CONSECUTIVE_CAPTURES 10 // how many frames get captured
#define EGIS0575_CAPTURE_DELAY 50 // how long to wait between each capture

// some frames can be dissmissed as not a finger, if more then 5 are dissmissed, we clear the frame buffer.
#define EGIS0575_MAX_CAPTURES_WITHOUT_FINGER_IN_ROW 5

/*
 * Image polling sequences
 *
 * First 4 bytes of packet to be sent is "EGIS", rest are unknown but a specific pattern was observed!
 * First 4 bytes of response is "SIGE"
 *
 * Partial sequence usually takes less than half of the sequences to return the image,
 * in-case it is not available for use, full sequence is going to be redirected after
 * the resonse to the third packet of partial sequence series.
 */
/* *INDENT-OFF* */
typedef struct Packet
{
  int            length;
  unsigned char *sequence;

  int            response_length;
} Packet;

static const Packet EGIS0575_PRE_RESET_PACKETS[] = {
  {.length = 6, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x00}, .response_length = 7},
  {.length = 6, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x01}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x97, 0x00, 0x00}, .response_length = 7} // this resets the fingerprintsensor maybe
};


static const Packet EGIS0575_POST_RESET_PACKETS[] = {
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x0a, 0xfd}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x35, 0x02}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x80, 0x00}, .response_length = 7},
  {.length = 6, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x80}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x0a, 0xfc}, .response_length = 7},
  {.length = 9, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x63, 0x01, 0x02, 0x0f, 0x03}, .response_length = 9},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x0c, 0x22}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x09, 0x83}, .response_length = 7},
  {.length = 13, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x63, 0x26, 0x06, 0x06, 0x60, 0x06, 0x05, 0x2f, 0x06}, .response_length = 13},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x0a, 0xf4}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x0c, 0x44}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x50, 0x03}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x50, 0x03}, .response_length = 7}
};

static const Packet EGIS0575_CALIBRATION_PACKET_1 =  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x73, 0x14, 0xec}, .response_length = 7};
static const Packet EGIS0575_CALIBRATION_PACKET_2 = {.length = 5356, .sequence = (unsigned char[]){
0x1c, 0x1e, 0x1f, 0x1e, 0x1f, 0x1b, 0x21, 0x1e, 0x1d, 0x20, 0x1e, 0x1f, 0x1f, 0x21, 0x1f, 0x1f, 0x20, 0x21, 0x22, 0x22, 0x1f, 0x22, 0x22, 0x23, 0x20, 0x21, 0x23, 0x21, 0x20, 0x20, 0x23, 0x20, 
0x20, 0x1d, 0x1f, 0x1d, 0x21, 0x21, 0x1f, 0x20, 0x20, 0x21, 0x1e, 0x1d, 0x1e, 0x1f, 0x22, 0x20, 0x20, 0x1c, 0x23, 0x1e, 0x20, 0x20, 0x1d, 0x22, 0x24, 0x1f, 0x22, 0x1f, 0x1e, 0x20, 0x1d, 0x1f, 
0x1f, 0x1d, 0x1e, 0x1c, 0x1b, 0x1d, 0x1a, 0x20, 0x1d, 0x1b, 0x1a, 0x1d, 0x1d, 0x1d, 0x21, 0x1c, 0x1d, 0x1a, 0x1d, 0x1d, 0x1d, 0x1f, 0x1c, 0x19, 0x1b, 0x1d, 0x1a, 0x1a, 0x1b, 0x19, 0x1a, 0x1b, 
0x18, 0x1d, 0x1c, 0x1b, 0x1a, 0x1a, 0x19, 0x1d, 0x1e, 0x1c, 0x21, 0x1f, 0x1f, 0x21, 0x1f, 0x20, 0x20, 0x1f, 0x1e, 0x1e, 0x24, 0x20, 0x20, 0x1d, 0x23, 0x22, 0x1e, 0x21, 0x23, 0x1f, 0x22, 0x23, 
0x1e, 0x20, 0x21, 0x1f, 0x25, 0x21, 0x22, 0x23, 0x22, 0x22, 0x22, 0x20, 0x20, 0x20, 0x24, 0x20, 0x20, 0x23, 0x1e, 0x1d, 0x1f, 0x24, 0x1e, 0x1f, 0x20, 0x1e, 0x1f, 0x21, 0x1e, 0x1f, 0x20, 0x20, 
0x1e, 0x1e, 0x1d, 0x1d, 0x1f, 0x1f, 0x1b, 0x20, 0x20, 0x1f, 0x1e, 0x20, 0x1f, 0x1d, 0x20, 0x1d, 0x20, 0x20, 0x1e, 0x1d, 0x1f, 0x21, 0x1d, 0x1f, 0x1e, 0x1c, 0x1e, 0x1b, 0x1c, 0x1a, 0x1a, 0x1d, 
0x1e, 0x1b, 0x1c, 0x1b, 0x19, 0x1f, 0x1d, 0x1c, 0x1b, 0x1c, 0x1e, 0x1a, 0x1d, 0x18, 0x1d, 0x1b, 0x1e, 0x1f, 0x1f, 0x1e, 0x1e, 0x1f, 0x1f, 0x21, 0x22, 0x1f, 0x22, 0x22, 0x23, 0x21, 0x21, 0x22, 
0x1f, 0x24, 0x1f, 0x20, 0x1f, 0x24, 0x21, 0x24, 0x24, 0x1e, 0x1f, 0x23, 0x21, 0x21, 0x20, 0x21, 0x1f, 0x21, 0x20, 0x20, 0x20, 0x22, 0x25, 0x22, 0x21, 0x1f, 0x23, 0x21, 0x1d, 0x20, 0x20, 0x1f, 
0x21, 0x22, 0x20, 0x1c, 0x21, 0x23, 0x20, 0x21, 0x1f, 0x1e, 0x1f, 0x21, 0x1e, 0x22, 0x1d, 0x1f, 0x1d, 0x1e, 0x1e, 0x1d, 0x21, 0x1e, 0x1f, 0x22, 0x1f, 0x1e, 0x1d, 0x22, 0x1d, 0x1e, 0x20, 0x1f, 
0x1f, 0x1b, 0x19, 0x1f, 0x1c, 0x1e, 0x1b, 0x20, 0x1d, 0x1e, 0x1b, 0x1f, 0x1d, 0x19, 0x1b, 0x1e, 0x1a, 0x19, 0x19, 0x1e, 0x1b, 0x1a, 0x1d, 0x1f, 0x1d, 0x20, 0x1d, 0x1e, 0x1e, 0x1e, 0x20, 0x1f, 
0x23, 0x24, 0x20, 0x1e, 0x22, 0x1e, 0x23, 0x1e, 0x23, 0x21, 0x21, 0x25, 0x22, 0x22, 0x21, 0x24, 0x23, 0x21, 0x24, 0x20, 0x22, 0x1f, 0x1f, 0x23, 0x1f, 0x21, 0x20, 0x20, 0x22, 0x21, 0x22, 0x1f, 
0x20, 0x20, 0x1f, 0x1c, 0x20, 0x22, 0x25, 0x1e, 0x22, 0x1f, 0x20, 0x22, 0x23, 0x22, 0x1f, 0x23, 0x20, 0x20, 0x21, 0x22, 0x22, 0x1c, 0x20, 0x1f, 0x1d, 0x1f, 0x1f, 0x1e, 0x1f, 0x1e, 0x20, 0x1c, 
0x21, 0x1c, 0x1f, 0x21, 0x20, 0x20, 0x1e, 0x20, 0x1f, 0x1f, 0x1f, 0x1c, 0x1b, 0x1c, 0x1b, 0x1b, 0x1b, 0x1a, 0x1b, 0x1b, 0x1b, 0x1b, 0x1c, 0x19, 0x1d, 0x1b, 0x1c, 0x1b, 0x1d, 0x1e, 0x1f, 0x1e, 
0x1d, 0x1e, 0x1e, 0x22, 0x1f, 0x20, 0x20, 0x1f, 0x21, 0x21, 0x22, 0x22, 0x26, 0x21, 0x22, 0x24, 0x21, 0x22, 0x1e, 0x20, 0x23, 0x24, 0x21, 0x21, 0x1e, 0x24, 0x20, 0x22, 0x21, 0x20, 0x26, 0x1e, 
0x1f, 0x22, 0x21, 0x22, 0x20, 0x1f, 0x20, 0x20, 0x1f, 0x22, 0x1f, 0x20, 0x1e, 0x20, 0x1d, 0x1f, 0x21, 0x20, 0x1e, 0x20, 0x1e, 0x22, 0x20, 0x20, 0x1d, 0x22, 0x23, 0x21, 0x1d, 0x20, 0x20, 0x1f, 
0x1e, 0x21, 0x20, 0x1d, 0x1a, 0x1b, 0x20, 0x1d, 0x1c, 0x1e, 0x20, 0x1e, 0x1e, 0x1d, 0x1d, 0x20, 0x1d, 0x1e, 0x1f, 0x1f, 0x1c, 0x1d, 0x1b, 0x1d, 0x1c, 0x1c, 0x1d, 0x1d, 0x1b, 0x1c, 0x1d, 0x1d, 
0x1a, 0x1f, 0x19, 0x1c, 0x1f, 0x1e, 0x1e, 0x1e, 0x1f, 0x1f, 0x1f, 0x1f, 0x21, 0x20, 0x1f, 0x21, 0x20, 0x20, 0x22, 0x1e, 0x21, 0x1f, 0x20, 0x1f, 0x22, 0x24, 0x20, 0x23, 0x20, 0x20, 0x22, 0x1e, 
0x21, 0x22, 0x1f, 0x20, 0x20, 0x1f, 0x1e, 0x22, 0x21, 0x1d, 0x1f, 0x22, 0x1f, 0x1e, 0x23, 0x23, 0x22, 0x20, 0x21, 0x23, 0x22, 0x26, 0x21, 0x1e, 0x1f, 0x20, 0x1e, 0x1f, 0x21, 0x22, 0x1f, 0x20, 
0x23, 0x22, 0x23, 0x1d, 0x1e, 0x1f, 0x1e, 0x21, 0x1f, 0x20, 0x20, 0x1f, 0x21, 0x1e, 0x22, 0x1f, 0x1e, 0x1e, 0x20, 0x1d, 0x20, 0x1d, 0x1d, 0x1b, 0x1c, 0x1d, 0x1b, 0x1a, 0x1e, 0x1c, 0x19, 0x1d, 
0x1d, 0x1c, 0x1b, 0x20, 0x1c, 0x1a, 0x1c, 0x19, 0x1b, 0x18, 0x1f, 0x1c, 0x1e, 0x1e, 0x1d, 0x1f, 0x20, 0x1e, 0x23, 0x21, 0x1f, 0x21, 0x22, 0x21, 0x23, 0x1e, 0x1f, 0x22, 0x1f, 0x20, 0x21, 0x24, 
0x26, 0x23, 0x22, 0x20, 0x24, 0x23, 0x22, 0x21, 0x20, 0x22, 0x22, 0x24, 0x21, 0x21, 0x1f, 0x22, 0x21, 0x21, 0x22, 0x20, 0x21, 0x23, 0x20, 0x23, 0x1f, 0x23, 0x1f, 0x22, 0x22, 0x21, 0x22, 0x1e, 
0x1f, 0x21, 0x21, 0x20, 0x1e, 0x20, 0x1e, 0x21, 0x25, 0x1e, 0x1e, 0x23, 0x1f, 0x22, 0x21, 0x1f, 0x1f, 0x20, 0x1e, 0x22, 0x20, 0x1e, 0x1d, 0x1f, 0x1d, 0x1f, 0x20, 0x20, 0x21, 0x1c, 0x1f, 0x1d, 
0x1c, 0x20, 0x1e, 0x1b, 0x1d, 0x1d, 0x1f, 0x1c, 0x1d, 0x1e, 0x1d, 0x1d, 0x1f, 0x1d, 0x1a, 0x1b, 0x16, 0x1a, 0x1d, 0x1f, 0x20, 0x1d, 0x21, 0x21, 0x1e, 0x21, 0x21, 0x22, 0x1d, 0x21, 0x24, 0x1e, 
0x21, 0x20, 0x22, 0x22, 0x22, 0x23, 0x22, 0x22, 0x22, 0x23, 0x23, 0x1e, 0x23, 0x1f, 0x23, 0x21, 0x20, 0x23, 0x23, 0x24, 0x21, 0x1e, 0x24, 0x21, 0x21, 0x22, 0x22, 0x20, 0x21, 0x1f, 0x23, 0x21, 
0x21, 0x25, 0x1f, 0x27, 0x1f, 0x22, 0x20, 0x20, 0x1e, 0x1c, 0x21, 0x1c, 0x22, 0x20, 0x1f, 0x20, 0x1c, 0x1d, 0x1b, 0x20, 0x1d, 0x1d, 0x21, 0x1d, 0x1e, 0x1f, 0x20, 0x1d, 0x1b, 0x20, 0x1b, 0x21, 
0x1f, 0x1d, 0x1e, 0x1f, 0x1c, 0x1c, 0x1e, 0x1c, 0x1f, 0x1a, 0x1b, 0x1b, 0x1d, 0x1b, 0x1c, 0x1c, 0x1e, 0x1c, 0x1d, 0x1c, 0x1e, 0x19, 0x1d, 0x1c, 0x1d, 0x1d, 0x20, 0x1e, 0x1d, 0x1f, 0x1d, 0x1e, 
0x1f, 0x21, 0x20, 0x21, 0x1d, 0x1e, 0x25, 0x1f, 0x20, 0x21, 0x22, 0x21, 0x22, 0x1f, 0x24, 0x26, 0x24, 0x21, 0x22, 0x23, 0x20, 0x22, 0x22, 0x23, 0x25, 0x21, 0x20, 0x23, 0x22, 0x22, 0x20, 0x22, 
0x1f, 0x24, 0x23, 0x22, 0x22, 0x1f, 0x20, 0x24, 0x22, 0x1f, 0x21, 0x21, 0x22, 0x21, 0x23, 0x1f, 0x1e, 0x1f, 0x21, 0x1f, 0x21, 0x1d, 0x22, 0x22, 0x1f, 0x20, 0x20, 0x20, 0x1f, 0x1f, 0x1d, 0x1c, 
0x1d, 0x1f, 0x1f, 0x1c, 0x1d, 0x1e, 0x20, 0x1f, 0x1d, 0x1e, 0x1c, 0x21, 0x1c, 0x1e, 0x1d, 0x1a, 0x1d, 0x1f, 0x1b, 0x1d, 0x1f, 0x1e, 0x1e, 0x1e, 0x1d, 0x1d, 0x1c, 0x1c, 0x1a, 0x1b, 0x1d, 0x1c, 
0x1b, 0x1d, 0x1d, 0x1f, 0x1d, 0x1e, 0x1f, 0x1e, 0x22, 0x20, 0x1e, 0x20, 0x1f, 0x21, 0x21, 0x1f, 0x20, 0x23, 0x21, 0x20, 0x21, 0x23, 0x1e, 0x21, 0x21, 0x28, 0x23, 0x20, 0x25, 0x1e, 0x21, 0x21, 
0x22, 0x22, 0x1f, 0x22, 0x22, 0x20, 0x1d, 0x20, 0x1f, 0x23, 0x20, 0x20, 0x21, 0x21, 0x1e, 0x1d, 0x21, 0x1e, 0x23, 0x1b, 0x21, 0x1f, 0x24, 0x20, 0x1e, 0x1f, 0x1f, 0x24, 0x21, 0x20, 0x19, 0x1e, 
0x22, 0x20, 0x1e, 0x1d, 0x1f, 0x1d, 0x1f, 0x1f, 0x1e, 0x1f, 0x1e, 0x1c, 0x1e, 0x20, 0x1e, 0x1a, 0x1e, 0x1f, 0x1c, 0x1a, 0x1e, 0x1d, 0x1c, 0x1d, 0x1a, 0x1e, 0x1b, 0x1d, 0x1e, 0x1a, 0x1b, 0x1b, 
0x1d, 0x1b, 0x16, 0x1a, 0x1c, 0x1a, 0x1c, 0x1e, 0x1e, 0x1d, 0x22, 0x22, 0x22, 0x1c, 0x1f, 0x20, 0x20, 0x23, 0x22, 0x22, 0x21, 0x24, 0x1f, 0x23, 0x25, 0x1f, 0x1f, 0x23, 0x22, 0x21, 0x22, 0x26, 
0x1f, 0x20, 0x22, 0x22, 0x1f, 0x25, 0x20, 0x21, 0x20, 0x1e, 0x21, 0x1f, 0x21, 0x21, 0x21, 0x21, 0x1e, 0x20, 0x21, 0x21, 0x22, 0x1d, 0x1d, 0x1f, 0x21, 0x21, 0x20, 0x1f, 0x21, 0x20, 0x1f, 0x1f, 
0x1f, 0x20, 0x22, 0x1e, 0x22, 0x20, 0x1e, 0x1f, 0x20, 0x22, 0x1f, 0x20, 0x1e, 0x1e, 0x22, 0x20, 0x21, 0x21, 0x1f, 0x21, 0x1b, 0x1d, 0x1d, 0x1c, 0x1f, 0x1e, 0x1d, 0x1e, 0x1b, 0x1c, 0x1b, 0x21, 
0x1c, 0x1b, 0x1c, 0x1c, 0x1b, 0x18, 0x1a, 0x1e, 0x1b, 0x1e, 0x18, 0x1c, 0x19, 0x1d, 0x1d, 0x1d, 0x1f, 0x1d, 0x21, 0x1f, 0x1e, 0x1d, 0x1f, 0x1f, 0x22, 0x23, 0x20, 0x20, 0x21, 0x22, 0x24, 0x21, 
0x21, 0x20, 0x21, 0x1f, 0x21, 0x23, 0x22, 0x20, 0x21, 0x24, 0x23, 0x20, 0x22, 0x23, 0x21, 0x20, 0x1f, 0x21, 0x21, 0x23, 0x20, 0x20, 0x24, 0x20, 0x20, 0x1f, 0x1e, 0x20, 0x21, 0x21, 0x22, 0x1f, 
0x20, 0x1e, 0x1f, 0x1e, 0x1d, 0x1e, 0x21, 0x21, 0x1d, 0x1b, 0x20, 0x1f, 0x1c, 0x1e, 0x20, 0x1c, 0x1d, 0x1f, 0x1e, 0x1f, 0x1f, 0x1a, 0x1d, 0x20, 0x1d, 0x1d, 0x1f, 0x1f, 0x1c, 0x1c, 0x1f, 0x1c, 
0x1b, 0x19, 0x1d, 0x1d, 0x1a, 0x1e, 0x1f, 0x1d, 0x1f, 0x1c, 0x1d, 0x19, 0x1a, 0x19, 0x1a, 0x1a, 0x19, 0x1a, 0x1b, 0x19, 0x1c, 0x1d, 0x1e, 0x20, 0x1d, 0x20, 0x1f, 0x1b, 0x21, 0x1f, 0x1f, 0x22, 
0x1e, 0x20, 0x21, 0x1f, 0x21, 0x22, 0x1f, 0x25, 0x20, 0x21, 0x1f, 0x22, 0x21, 0x22, 0x22, 0x23, 0x21, 0x1f, 0x21, 0x20, 0x22, 0x22, 0x22, 0x22, 0x23, 0x21, 0x25, 0x1f, 0x20, 0x21, 0x1e, 0x22, 
0x1d, 0x1d, 0x21, 0x22, 0x21, 0x20, 0x1e, 0x22, 0x1d, 0x1e, 0x1e, 0x22, 0x20, 0x1e, 0x25, 0x1d, 0x20, 0x1c, 0x1d, 0x1e, 0x1f, 0x1f, 0x20, 0x1f, 0x21, 0x1f, 0x1f, 0x1e, 0x1c, 0x21, 0x20, 0x1f, 
0x1f, 0x1d, 0x1e, 0x1f, 0x21, 0x1d, 0x1f, 0x1b, 0x1a, 0x1e, 0x1a, 0x1b, 0x1a, 0x1c, 0x1e, 0x19, 0x1b, 0x18, 0x1d, 0x1d, 0x1c, 0x1f, 0x1a, 0x19, 0x19, 0x1b, 0x1b, 0x1c, 0x1e, 0x20, 0x1f, 0x1f, 
0x1d, 0x1e, 0x1e, 0x21, 0x1f, 0x22, 0x1e, 0x1f, 0x21, 0x22, 0x25, 0x20, 0x23, 0x21, 0x21, 0x22, 0x22, 0x23, 0x23, 0x21, 0x22, 0x25, 0x1e, 0x24, 0x20, 0x20, 0x24, 0x23, 0x23, 0x23, 0x20, 0x20, 
0x21, 0x1f, 0x20, 0x22, 0x23, 0x21, 0x20, 0x21, 0x23, 0x23, 0x20, 0x21, 0x23, 0x24, 0x1e, 0x1f, 0x25, 0x20, 0x1f, 0x22, 0x1f, 0x20, 0x1f, 0x1c, 0x20, 0x21, 0x1f, 0x1d, 0x22, 0x1f, 0x1e, 0x1f, 
0x20, 0x1d, 0x1c, 0x20, 0x20, 0x1d, 0x1e, 0x1c, 0x20, 0x1f, 0x1d, 0x1e, 0x1e, 0x1e, 0x1c, 0x1c, 0x20, 0x1b, 0x1d, 0x1b, 0x1d, 0x1e, 0x1b, 0x1b, 0x1c, 0x1e, 0x18, 0x19, 0x1c, 0x1a, 0x16, 0x1b, 
0x1d, 0x18, 0x1e, 0x1e, 0x21, 0x1f, 0x1b, 0x20, 0x21, 0x20, 0x21, 0x1e, 0x23, 0x1e, 0x1f, 0x22, 0x1f, 0x1e, 0x24, 0x22, 0x25, 0x24, 0x22, 0x20, 0x1f, 0x22, 0x1e, 0x21, 0x20, 0x20, 0x1f, 0x24, 
0x20, 0x1f, 0x25, 0x23, 0x21, 0x20, 0x1d, 0x1f, 0x20, 0x1f, 0x20, 0x20, 0x1e, 0x20, 0x1f, 0x22, 0x1f, 0x1f, 0x22, 0x20, 0x20, 0x1f, 0x1e, 0x1f, 0x23, 0x1d, 0x1e, 0x1f, 0x21, 0x20, 0x1d, 0x1f, 
0x22, 0x1e, 0x1f, 0x1d, 0x24, 0x1f, 0x1d, 0x1e, 0x1e, 0x1f, 0x1f, 0x1e, 0x1e, 0x21, 0x22, 0x1b, 0x1d, 0x1f, 0x1e, 0x1e, 0x1b, 0x1e, 0x19, 0x21, 0x19, 0x1b, 0x1a, 0x19, 0x1c, 0x1b, 0x1c, 0x1b, 
0x1a, 0x1a, 0x1b, 0x1d, 0x18, 0x17, 0x17, 0x19, 0x1b, 0x1b, 0x1e, 0x1e, 0x1f, 0x1e, 0x1e, 0x1e, 0x20, 0x1d, 0x20, 0x21, 0x21, 0x24, 0x23, 0x24, 0x23, 0x22, 0x22, 0x21, 0x23, 0x1e, 0x22, 0x22, 
0x22, 0x20, 0x1e, 0x23, 0x22, 0x1f, 0x1f, 0x21, 0x21, 0x21, 0x21, 0x21, 0x22, 0x1e, 0x20, 0x1e, 0x21, 0x22, 0x21, 0x21, 0x1e, 0x22, 0x20, 0x22, 0x1f, 0x21, 0x1f, 0x20, 0x1f, 0x1d, 0x1d, 0x22, 
0x1e, 0x20, 0x22, 0x1e, 0x1d, 0x1f, 0x21, 0x1e, 0x1e, 0x1e, 0x1e, 0x1d, 0x21, 0x1e, 0x20, 0x20, 0x1c, 0x1f, 0x1f, 0x1f, 0x1f, 0x1d, 0x1e, 0x1d, 0x1f, 0x20, 0x1a, 0x1a, 0x1f, 0x1d, 0x1d, 0x1e, 
0x1d, 0x19, 0x1f, 0x1e, 0x17, 0x1b, 0x1c, 0x20, 0x1c, 0x1e, 0x1c, 0x1d, 0x1b, 0x17, 0x1b, 0x1a, 0x1e, 0x20, 0x1e, 0x1e, 0x1d, 0x1e, 0x1f, 0x1d, 0x1e, 0x1f, 0x1f, 0x20, 0x21, 0x23, 0x20, 0x20, 
0x22, 0x23, 0x22, 0x22, 0x21, 0x23, 0x26, 0x21, 0x27, 0x23, 0x26, 0x24, 0x23, 0x22, 0x25, 0x21, 0x23, 0x20, 0x22, 0x22, 0x21, 0x25, 0x1d, 0x22, 0x22, 0x1f, 0x21, 0x21, 0x1e, 0x20, 0x25, 0x22, 
0x23, 0x1c, 0x22, 0x22, 0x1f, 0x21, 0x22, 0x21, 0x1f, 0x23, 0x1f, 0x1e, 0x1e, 0x23, 0x1f, 0x1f, 0x21, 0x1f, 0x20, 0x1f, 0x20, 0x1e, 0x20, 0x22, 0x20, 0x1f, 0x22, 0x1c, 0x20, 0x21, 0x1f, 0x1e, 
0x20, 0x20, 0x1e, 0x1e, 0x1d, 0x1e, 0x20, 0x1c, 0x1a, 0x1e, 0x1b, 0x1e, 0x1f, 0x1c, 0x1c, 0x1b, 0x1c, 0x1c, 0x1a, 0x1e, 0x1a, 0x1c, 0x19, 0x1e, 0x1f, 0x1e, 0x21, 0x21, 0x1e, 0x21, 0x1f, 0x25, 
0x20, 0x20, 0x1f, 0x1f, 0x25, 0x21, 0x20, 0x24, 0x21, 0x24, 0x20, 0x1f, 0x23, 0x21, 0x23, 0x21, 0x24, 0x23, 0x24, 0x23, 0x27, 0x21, 0x23, 0x20, 0x1f, 0x21, 0x22, 0x1f, 0x23, 0x23, 0x20, 0x22, 
0x22, 0x24, 0x21, 0x20, 0x25, 0x1f, 0x1f, 0x1e, 0x23, 0x23, 0x22, 0x21, 0x20, 0x22, 0x21, 0x21, 0x24, 0x1e, 0x1e, 0x1e, 0x1f, 0x23, 0x1e, 0x1f, 0x20, 0x1f, 0x1d, 0x1e, 0x1d, 0x1d, 0x20, 0x1c, 
0x1e, 0x1f, 0x1f, 0x1d, 0x1e, 0x1b, 0x1c, 0x20, 0x1f, 0x20, 0x1f, 0x1a, 0x1b, 0x1e, 0x1d, 0x1b, 0x1c, 0x1e, 0x17, 0x1b, 0x1f, 0x1a, 0x1c, 0x1d, 0x18, 0x16, 0x1c, 0x1b, 0x1a, 0x19, 0x1d, 0x1f, 
0x22, 0x1f, 0x1d, 0x20, 0x21, 0x22, 0x1d, 0x20, 0x21, 0x20, 0x1f, 0x22, 0x22, 0x21, 0x21, 0x1f, 0x20, 0x20, 0x1f, 0x21, 0x1e, 0x21, 0x21, 0x20, 0x21, 0x21, 0x22, 0x20, 0x20, 0x1e, 0x24, 0x23, 
0x21, 0x21, 0x1f, 0x22, 0x22, 0x21, 0x22, 0x22, 0x1f, 0x20, 0x1e, 0x22, 0x20, 0x21, 0x21, 0x1f, 0x21, 0x20, 0x20, 0x20, 0x1c, 0x24, 0x20, 0x1f, 0x20, 0x1e, 0x1e, 0x1f, 0x22, 0x20, 0x24, 0x1f, 
0x22, 0x1e, 0x1f, 0x20, 0x20, 0x22, 0x1d, 0x21, 0x1d, 0x1d, 0x1c, 0x1e, 0x1b, 0x1d, 0x1f, 0x1f, 0x1d, 0x1c, 0x1e, 0x1c, 0x1d, 0x1a, 0x1d, 0x20, 0x1d, 0x1a, 0x1a, 0x1b, 0x1b, 0x1a, 0x1a, 0x1d, 
0x1a, 0x1b, 0x1a, 0x1c, 0x17, 0x1d, 0x1e, 0x1e, 0x1c, 0x1c, 0x1c, 0x1f, 0x1e, 0x1e, 0x1e, 0x21, 0x22, 0x20, 0x22, 0x23, 0x21, 0x24, 0x24, 0x20, 0x1e, 0x23, 0x21, 0x23, 0x20, 0x20, 0x22, 0x1f, 
0x22, 0x1e, 0x21, 0x22, 0x21, 0x22, 0x22, 0x21, 0x22, 0x21, 0x22, 0x23, 0x1e, 0x1f, 0x22, 0x21, 0x22, 0x22, 0x22, 0x22, 0x25, 0x1e, 0x23, 0x1f, 0x1f, 0x1e, 0x1f, 0x1b, 0x1f, 0x20, 0x1f, 0x20, 
0x1d, 0x20, 0x1f, 0x21, 0x21, 0x1d, 0x1d, 0x22, 0x1f, 0x20, 0x20, 0x1d, 0x21, 0x1d, 0x21, 0x20, 0x1e, 0x1b, 0x22, 0x1b, 0x1d, 0x1a, 0x23, 0x1d, 0x1d, 0x1d, 0x1c, 0x1e, 0x1f, 0x1c, 0x1e, 0x1e, 
0x1b, 0x1b, 0x1b, 0x1d, 0x1b, 0x19, 0x1f, 0x1e, 0x1d, 0x1a, 0x1e, 0x17, 0x20, 0x1e, 0x1c, 0x1f, 0x21, 0x20, 0x21, 0x22, 0x21, 0x21, 0x21, 0x20, 0x21, 0x22, 0x22, 0x1f, 0x23, 0x22, 0x21, 0x23, 
0x23, 0x22, 0x23, 0x23, 0x23, 0x23, 0x22, 0x21, 0x22, 0x1e, 0x24, 0x21, 0x22, 0x22, 0x21, 0x23, 0x21, 0x21, 0x1e, 0x22, 0x21, 0x24, 0x21, 0x23, 0x1e, 0x20, 0x1f, 0x22, 0x1a, 0x23, 0x20, 0x20, 
0x1b, 0x1f, 0x21, 0x20, 0x1c, 0x25, 0x20, 0x20, 0x20, 0x1e, 0x1e, 0x20, 0x1e, 0x20, 0x1e, 0x1f, 0x1d, 0x21, 0x21, 0x1f, 0x1e, 0x1f, 0x22, 0x1e, 0x1e, 0x1e, 0x1f, 0x1d, 0x1f, 0x20, 0x20, 0x1e, 
0x1d, 0x1c, 0x1d, 0x1c, 0x1b, 0x21, 0x1c, 0x1c, 0x19, 0x1a, 0x1c, 0x19, 0x1d, 0x1f, 0x1a, 0x1c, 0x19, 0x1b, 0x1a, 0x20, 0x1e, 0x1f, 0x20, 0x21, 0x20, 0x21, 0x22, 0x23, 0x23, 0x1f, 0x22, 0x22, 
0x21, 0x23, 0x23, 0x25, 0x26, 0x25, 0x23, 0x21, 0x20, 0x22, 0x23, 0x22, 0x23, 0x23, 0x24, 0x24, 0x22, 0x23, 0x21, 0x23, 0x21, 0x22, 0x23, 0x1f, 0x22, 0x1f, 0x21, 0x21, 0x21, 0x21, 0x20, 0x22, 
0x24, 0x21, 0x22, 0x21, 0x24, 0x27, 0x1f, 0x1d, 0x20, 0x1e, 0x1f, 0x22, 0x21, 0x1e, 0x1d, 0x1e, 0x23, 0x21, 0x20, 0x21, 0x26, 0x1d, 0x21, 0x1f, 0x23, 0x22, 0x1d, 0x20, 0x20, 0x1b, 0x21, 0x20, 
0x20, 0x1d, 0x1e, 0x1e, 0x1e, 0x1e, 0x1b, 0x1d, 0x1f, 0x1e, 0x1d, 0x1e, 0x1e, 0x1a, 0x1e, 0x21, 0x1c, 0x1a, 0x1d, 0x1e, 0x1b, 0x1f, 0x19, 0x17, 0x19, 0x1b, 0x1b, 0x1c, 0x1e, 0x1e, 0x1f, 0x23, 
0x1f, 0x20, 0x22, 0x20, 0x1f, 0x21, 0x21, 0x20, 0x1f, 0x21, 0x24, 0x24, 0x25, 0x23, 0x29, 0x21, 0x22, 0x26, 0x22, 0x21, 0x23, 0x25, 0x21, 0x22, 0x21, 0x23, 0x21, 0x25, 0x21, 0x22, 0x1f, 0x1e, 
0x20, 0x20, 0x21, 0x1f, 0x24, 0x23, 0x1c, 0x23, 0x22, 0x23, 0x1c, 0x22, 0x1f, 0x21, 0x1d, 0x26, 0x21, 0x22, 0x20, 0x23, 0x21, 0x20, 0x1e, 0x20, 0x1f, 0x1f, 0x1c, 0x20, 0x1f, 0x1f, 0x1b, 0x23, 
0x1e, 0x22, 0x20, 0x20, 0x1d, 0x22, 0x20, 0x21, 0x1f, 0x1b, 0x1c, 0x21, 0x1b, 0x18, 0x1d, 0x22, 0x1b, 0x1e, 0x1f, 0x1e, 0x1c, 0x1b, 0x1d, 0x1a, 0x1b, 0x1d, 0x1d, 0x1f, 0x1c, 0x1c, 0x20, 0x1b, 
0x19, 0x1e, 0x1b, 0x1e, 0x1f, 0x1f, 0x23, 0x1f, 0x21, 0x20, 0x20, 0x25, 0x1e, 0x20, 0x23, 0x27, 0x22, 0x25, 0x23, 0x1f, 0x20, 0x23, 0x24, 0x26, 0x23, 0x23, 0x23, 0x23, 0x24, 0x20, 0x21, 0x22, 
0x23, 0x22, 0x20, 0x22, 0x22, 0x26, 0x22, 0x23, 0x23, 0x25, 0x22, 0x22, 0x23, 0x25, 0x23, 0x26, 0x22, 0x25, 0x22, 0x27, 0x22, 0x1f, 0x22, 0x1f, 0x26, 0x23, 0x1f, 0x21, 0x21, 0x21, 0x1e, 0x21, 
0x1f, 0x1f, 0x24, 0x20, 0x1e, 0x21, 0x1c, 0x20, 0x21, 0x1f, 0x21, 0x1c, 0x20, 0x20, 0x22, 0x20, 0x1d, 0x1c, 0x1d, 0x1d, 0x19, 0x19, 0x24, 0x1a, 0x1e, 0x1b, 0x1a, 0x1e, 0x1e, 0x1d, 0x18, 0x1c, 
0x1c, 0x1b, 0x19, 0x1c, 0x1a, 0x18, 0x19, 0x1a, 0x1d, 0x1f, 0x1d, 0x1f, 0x22, 0x1e, 0x1f, 0x1f, 0x1e, 0x23, 0x21, 0x23, 0x22, 0x25, 0x20, 0x23, 0x20, 0x22, 0x1f, 0x24, 0x24, 0x22, 0x24, 0x23, 
0x20, 0x25, 0x22, 0x22, 0x21, 0x21, 0x24, 0x25, 0x20, 0x21, 0x22, 0x1e, 0x21, 0x22, 0x21, 0x22, 0x26, 0x24, 0x1f, 0x22, 0x22, 0x24, 0x26, 0x22, 0x22, 0x1f, 0x22, 0x21, 0x1f, 0x22, 0x1e, 0x23, 
0x1f, 0x1c, 0x20, 0x1e, 0x1e, 0x21, 0x20, 0x23, 0x1f, 0x23, 0x1e, 0x20, 0x1f, 0x21, 0x21, 0x21, 0x1e, 0x1e, 0x20, 0x1d, 0x1f, 0x1f, 0x1c, 0x1d, 0x1e, 0x1a, 0x20, 0x1e, 0x1b, 0x1c, 0x1b, 0x1f, 
0x1c, 0x1d, 0x1d, 0x1e, 0x1c, 0x1a, 0x19, 0x1b, 0x1a, 0x1b, 0x1a, 0x1a, 0x1b, 0x1f, 0x17, 0x1c, 0x1f, 0x21, 0x1e, 0x20, 0x20, 0x23, 0x23, 0x20, 0x1c, 0x24, 0x22, 0x20, 0x22, 0x1f, 0x21, 0x23, 
0x22, 0x25, 0x26, 0x22, 0x23, 0x21, 0x26, 0x22, 0x20, 0x25, 0x24, 0x22, 0x23, 0x25, 0x23, 0x24, 0x26, 0x25, 0x22, 0x23, 0x24, 0x24, 0x21, 0x24, 0x20, 0x23, 0x22, 0x24, 0x22, 0x22, 0x22, 0x21, 
0x25, 0x22, 0x21, 0x20, 0x1f, 0x21, 0x23, 0x24, 0x24, 0x25, 0x1d, 0x21, 0x1f, 0x24, 0x1f, 0x21, 0x25, 0x1f, 0x1f, 0x23, 0x24, 0x23, 0x1f, 0x21, 0x23, 0x21, 0x21, 0x20, 0x23, 0x1d, 0x1f, 0x1e, 
0x1d, 0x1b, 0x1b, 0x1e, 0x20, 0x1d, 0x1f, 0x1b, 0x1b, 0x1d, 0x1c, 0x1c, 0x1c, 0x1d, 0x17, 0x1a, 0x1f, 0x1c, 0x1e, 0x1f, 0x21, 0x19, 0x1b, 0x1f, 0x20, 0x1f, 0x20, 0x1f, 0x20, 0x21, 0x23, 0x1c, 
0x23, 0x22, 0x21, 0x23, 0x20, 0x20, 0x29, 0x21, 0x21, 0x22, 0x23, 0x23, 0x24, 0x1f, 0x27, 0x22, 0x24, 0x1e, 0x20, 0x26, 0x25, 0x23, 0x1e, 0x21, 0x20, 0x21, 0x20, 0x1e, 0x1c, 0x21, 0x21, 0x20, 
0x21, 0x24, 0x20, 0x1f, 0x21, 0x20, 0x22, 0x26, 0x23, 0x22, 0x20, 0x23, 0x20, 0x1d, 0x21, 0x1e, 0x1e, 0x1e, 0x1f, 0x22, 0x22, 0x23, 0x20, 0x21, 0x1f, 0x21, 0x19, 0x1e, 0x1d, 0x1d, 0x20, 0x1e, 
0x1e, 0x1f, 0x1b, 0x1e, 0x1d, 0x1a, 0x1d, 0x1e, 0x1b, 0x1c, 0x18, 0x18, 0x1c, 0x1c, 0x1b, 0x1b, 0x1a, 0x1a, 0x1a, 0x19, 0x1c, 0x1d, 0x1d, 0x1c, 0x1c, 0x1a, 0x17, 0x1c, 0x1e, 0x1d, 0x1d, 0x22, 
0x21, 0x1e, 0x23, 0x21, 0x21, 0x21, 0x1e, 0x22, 0x22, 0x21, 0x20, 0x23, 0x22, 0x22, 0x1f, 0x22, 0x21, 0x20, 0x24, 0x21, 0x26, 0x25, 0x27, 0x23, 0x26, 0x1e, 0x22, 0x22, 0x24, 0x21, 0x25, 0x25, 
0x26, 0x23, 0x21, 0x20, 0x20, 0x21, 0x27, 0x1f, 0x21, 0x1e, 0x20, 0x1e, 0x24, 0x22, 0x21, 0x25, 0x24, 0x1b, 0x23, 0x1e, 0x21, 0x1f, 0x24, 0x20, 0x1d, 0x1f, 0x20, 0x1f, 0x1e, 0x1f, 0x1f, 0x21, 
0x1f, 0x1f, 0x22, 0x1d, 0x1b, 0x1e, 0x23, 0x21, 0x1f, 0x1e, 0x1f, 0x20, 0x1e, 0x21, 0x1f, 0x1c, 0x1f, 0x19, 0x1d, 0x1b, 0x18, 0x1a, 0x1f, 0x1c, 0x1a, 0x1b, 0x1b, 0x1b, 0x1b, 0x1b, 0x1b, 0x1c, 
0x1a, 0x1b, 0x1b, 0x17, 0x1d, 0x1e, 0x1b, 0x1d, 0x20, 0x1f, 0x23, 0x21, 0x21, 0x22, 0x23, 0x1f, 0x1f, 0x27, 0x20, 0x27, 0x20, 0x23, 0x26, 0x20, 0x23, 0x24, 0x21, 0x22, 0x23, 0x23, 0x25, 0x23, 
0x25, 0x1f, 0x24, 0x23, 0x24, 0x1f, 0x20, 0x20, 0x26, 0x24, 0x22, 0x21, 0x23, 0x22, 0x21, 0x21, 0x1f, 0x21, 0x20, 0x1f, 0x23, 0x26, 0x23, 0x1e, 0x20, 0x22, 0x23, 0x24, 0x21, 0x20, 0x20, 0x20, 
0x22, 0x1f, 0x1f, 0x1c, 0x20, 0x24, 0x23, 0x1c, 0x1e, 0x1f, 0x1f, 0x20, 0x23, 0x1b, 0x22, 0x1e, 0x1d, 0x21, 0x21, 0x20, 0x1e, 0x1c, 0x21, 0x1e, 0x1a, 0x1e, 0x1e, 0x1d, 0x1a, 0x1b, 0x1d, 0x1c, 
0x1b, 0x1a, 0x1c, 0x1a, 0x19, 0x1c, 0x1d, 0x1c, 0x1a, 0x1e, 0x19, 0x1a, 0x22, 0x21, 0x1d, 0x1d, 0x21, 0x22, 0x22, 0x23, 0x21, 0x24, 0x23, 0x1f, 0x25, 0x24, 0x23, 0x1d, 0x24, 0x23, 0x22, 0x24, 
0x23, 0x24, 0x24, 0x20, 0x21, 0x28, 0x23, 0x22, 0x23, 0x21, 0x21, 0x21, 0x22, 0x20, 0x1e, 0x21, 0x21, 0x22, 0x23, 0x21, 0x21, 0x1e, 0x1f, 0x1e, 0x22, 0x20, 0x21, 0x26, 0x24, 0x23, 0x1e, 0x1f, 
0x1e, 0x21, 0x1e, 0x1e, 0x21, 0x23, 0x1f, 0x1d, 0x1e, 0x22, 0x1f, 0x1e, 0x23, 0x23, 0x21, 0x1e, 0x1f, 0x1e, 0x22, 0x21, 0x20, 0x20, 0x1d, 0x1d, 0x22, 0x20, 0x1e, 0x1c, 0x1d, 0x20, 0x1c, 0x1f, 
0x1f, 0x1c, 0x1d, 0x19, 0x1e, 0x1e, 0x1a, 0x1c, 0x1e, 0x1b, 0x1b, 0x1c, 0x1f, 0x1a, 0x1b, 0x1b, 0x1c, 0x1b, 0x1c, 0x1e, 0x1d, 0x22, 0x1f, 0x21, 0x22, 0x21, 0x20, 0x24, 0x23, 0x23, 0x25, 0x21, 
0x28, 0x21, 0x21, 0x21, 0x22, 0x20, 0x22, 0x20, 0x26, 0x22, 0x23, 0x22, 0x27, 0x21, 0x24, 0x23, 0x20, 0x21, 0x1f, 0x21, 0x22, 0x24, 0x22, 0x23, 0x24, 0x22, 0x1e, 0x23, 0x22, 0x21, 0x20, 0x1e, 
0x20, 0x22, 0x1d, 0x21, 0x1f, 0x22, 0x24, 0x1f, 0x1f, 0x1c, 0x22, 0x1e, 0x20, 0x1e, 0x1e, 0x22, 0x21, 0x1e, 0x20, 0x21, 0x1f, 0x23, 0x21, 0x21, 0x1d, 0x1e, 0x20, 0x22, 0x1f, 0x1f, 0x1d, 0x1f, 
0x1f, 0x1e, 0x1b, 0x1f, 0x1d, 0x1d, 0x1d, 0x1d, 0x1e, 0x1e, 0x21, 0x1b, 0x1a, 0x1a, 0x1c, 0x1e, 0x1b, 0x1c, 0x1b, 0x1b, 0x1a, 0x19, 0x1b, 0x1c, 0x1a, 0x1d, 0x1d, 0x1f, 0x1f, 0x20, 0x1e, 0x1f, 
0x1e, 0x21, 0x1f, 0x22, 0x22, 0x21, 0x22, 0x25, 0x21, 0x21, 0x21, 0x21, 0x22, 0x23, 0x21, 0x21, 0x26, 0x22, 0x21, 0x23, 0x22, 0x1f, 0x23, 0x20, 0x25, 0x21, 0x23, 0x1f, 0x22, 0x21, 0x24, 0x1f, 
0x21, 0x22, 0x21, 0x22, 0x23, 0x21, 0x23, 0x20, 0x20, 0x1d, 0x23, 0x1f, 0x21, 0x20, 0x24, 0x21, 0x22, 0x1d, 0x24, 0x21, 0x1f, 0x1f, 0x21, 0x21, 0x1f, 0x22, 0x1f, 0x20, 0x1f, 0x1e, 0x21, 0x1e, 
0x20, 0x20, 0x1e, 0x20, 0x1d, 0x21, 0x1f, 0x21, 0x1f, 0x1e, 0x20, 0x1e, 0x1b, 0x1d, 0x1c, 0x1c, 0x1c, 0x1b, 0x1b, 0x1a, 0x1b, 0x1b, 0x1d, 0x1d, 0x1c, 0x1b, 0x1e, 0x19, 0x1e, 0x17, 0x1e, 0x1a, 
0x1d, 0x1e, 0x1f, 0x20, 0x1e, 0x1f, 0x1f, 0x1f, 0x21, 0x21, 0x20, 0x1f, 0x20, 0x20, 0x20, 0x22, 0x22, 0x23, 0x24, 0x25, 0x20, 0x21, 0x23, 0x25, 0x20, 0x23, 0x24, 0x22, 0x20, 0x23, 0x23, 0x22, 
0x24, 0x22, 0x24, 0x23, 0x21, 0x23, 0x24, 0x21, 0x20, 0x24, 0x25, 0x21, 0x1e, 0x1f, 0x21, 0x23, 0x20, 0x21, 0x21, 0x1d, 0x21, 0x22, 0x21, 0x1d, 0x1f, 0x22, 0x1f, 0x1f, 0x20, 0x1c, 0x23, 0x20, 
0x21, 0x20, 0x20, 0x1f, 0x1d, 0x1f, 0x20, 0x1f, 0x22, 0x1f, 0x1d, 0x22, 0x1e, 0x21, 0x1d, 0x21, 0x1e, 0x20, 0x1d, 0x1c, 0x1e, 0x1b, 0x1b, 0x1c, 0x1b, 0x1e, 0x1f, 0x19, 0x19, 0x1e, 0x1e, 0x1a, 
0x1a, 0x23, 0x1f, 0x1b, 0x19, 0x1a, 0x18, 0x1d, 0x1f, 0x1c, 0x1e, 0x1d, 0x22, 0x20, 0x1e, 0x20, 0x1d, 0x22, 0x20, 0x21, 0x24, 0x22, 0x22, 0x21, 0x25, 0x24, 0x25, 0x22, 0x22, 0x25, 0x22, 0x24, 
0x24, 0x25, 0x23, 0x21, 0x22, 0x23, 0x21, 0x22, 0x21, 0x22, 0x23, 0x1f, 0x22, 0x21, 0x26, 0x20, 0x23, 0x20, 0x22, 0x23, 0x21, 0x22, 0x1f, 0x1f, 0x20, 0x21, 0x24, 0x23, 0x23, 0x20, 0x1f, 0x21, 
0x1f, 0x22, 0x1f, 0x20, 0x20, 0x21, 0x1f, 0x1e, 0x20, 0x20, 0x1f, 0x1d, 0x20, 0x22, 0x20, 0x1c, 0x22, 0x1f, 0x1d, 0x1e, 0x22, 0x20, 0x1e, 0x1d, 0x1d, 0x1f, 0x1b, 0x1d, 0x1d, 0x1e, 0x1d, 0x1d, 
0x1e, 0x1c, 0x1b, 0x1c, 0x1b, 0x1a, 0x1a, 0x1c, 0x1b, 0x1d, 0x1e, 0x1e, 0x1d, 0x19, 0x1b, 0x1d, 0x20, 0x1e, 0x1e, 0x1d, 0x20, 0x1e, 0x22, 0x1f, 0x20, 0x25, 0x20, 0x1f, 0x22, 0x22, 0x22, 0x22, 
0x23, 0x22, 0x20, 0x20, 0x20, 0x24, 0x25, 0x24, 0x22, 0x22, 0x21, 0x22, 0x21, 0x21, 0x20, 0x23, 0x21, 0x21, 0x1e, 0x1f, 0x21, 0x20, 0x20, 0x24, 0x23, 0x21, 0x21, 0x23, 0x22, 0x21, 0x20, 0x1e, 
0x20, 0x1e, 0x22, 0x18, 0x1f, 0x22, 0x20, 0x1f, 0x21, 0x20, 0x20, 0x1f, 0x21, 0x1d, 0x1e, 0x1f, 0x21, 0x1f, 0x1e, 0x20, 0x1e, 0x1a, 0x1e, 0x21, 0x1f, 0x1f, 0x1f, 0x22, 0x1c, 0x1c, 0x1a, 0x1e, 
0x1d, 0x21, 0x1d, 0x1c, 0x1c, 0x1c, 0x1c, 0x1d, 0x1b, 0x1c, 0x1b, 0x18, 0x1d, 0x1b, 0x19, 0x19, 0x19, 0x1c, 0x1a, 0x1d, 0x18, 0x1b, 0x21, 0x1e, 0x20, 0x22, 0x1c, 0x20, 0x1e, 0x23, 0x21, 0x1f, 
0x24, 0x21, 0x21, 0x22, 0x26, 0x25, 0x25, 0x20, 0x22, 0x24, 0x24, 0x26, 0x21, 0x23, 0x24, 0x21, 0x21, 0x26, 0x29, 0x22, 0x27, 0x25, 0x24, 0x24, 0x22, 0x24, 0x22, 0x22, 0x22, 0x23, 0x23, 0x24, 
0x21, 0x22, 0x26, 0x26, 0x20, 0x25, 0x1f, 0x1e, 0x21, 0x20, 0x24, 0x24, 0x21, 0x22, 0x23, 0x23, 0x1e, 0x21, 0x24, 0x20, 0x1e, 0x1f, 0x20, 0x20, 0x23, 0x20, 0x21, 0x1f, 0x1f, 0x1d, 0x1f, 0x1f, 
0x1d, 0x1f, 0x1f, 0x23, 0x1b, 0x1e, 0x1c, 0x1b, 0x1c, 0x22, 0x1b, 0x1e, 0x1e, 0x1d, 0x1c, 0x1c, 0x1d, 0x19, 0x1e, 0x1b, 0x1c, 0x1a, 0x1b, 0x1b, 0x1b, 0x1a, 0x1c, 0x1a, 0x1b, 0x1e, 0x21, 0x1c, 
0x1e, 0x1f, 0x20, 0x1f, 0x22, 0x1f, 0x22, 0x22, 0x20, 0x24, 0x24, 0x22, 0x23, 0x24, 0x23, 0x24, 0x22, 0x22, 0x21, 0x22, 0x24, 0x23, 0x24, 0x24, 0x21, 0x23, 0x21, 0x25, 0x24, 0x21, 0x23, 0x25, 
0x21, 0x1f, 0x22, 0x1f, 0x20, 0x20, 0x21, 0x25, 0x22, 0x21, 0x21, 0x22, 0x21, 0x25, 0x22, 0x22, 0x20, 0x22, 0x1f, 0x22, 0x1e, 0x1c, 0x1d, 0x20, 0x20, 0x1e, 0x24, 0x22, 0x1f, 0x21, 0x1d, 0x1f, 
0x1d, 0x20, 0x1f, 0x1e, 0x1f, 0x21, 0x1f, 0x1d, 0x23, 0x1b, 0x1f, 0x21, 0x1b, 0x1a, 0x23, 0x1b, 0x1b, 0x1b, 0x1c, 0x1b, 0x1c, 0x1d, 0x1d, 0x1b, 0x19, 0x1b, 0x1c, 0x1b, 0x1d, 0x1c, 0x1a, 0x1e, 
0x1a, 0x1b, 0x1a, 0x1a, 0x20, 0x20, 0x1f, 0x1f, 0x20, 0x1e, 0x1f, 0x20, 0x21, 0x1e, 0x21, 0x20, 0x23, 0x22, 0x23, 0x24, 0x23, 0x22, 0x23, 0x21, 0x21, 0x24, 0x24, 0x25, 0x21, 0x25, 0x22, 0x24, 
0x23, 0x20, 0x24, 0x24, 0x21, 0x23, 0x22, 0x23, 0x22, 0x21, 0x1e, 0x22, 0x21, 0x24, 0x22, 0x1f, 0x25, 0x26, 0x20, 0x1f, 0x20, 0x23, 0x1f, 0x1d, 0x1f, 0x22, 0x1f, 0x1f, 0x21, 0x21, 0x1d, 0x1f, 
0x20, 0x23, 0x1e, 0x20, 0x1f, 0x21, 0x1e, 0x1d, 0x1f, 0x1b, 0x21, 0x21, 0x1f, 0x1e, 0x1f, 0x1d, 0x20, 0x21, 0x1d, 0x1f, 0x1d, 0x1d, 0x1e, 0x1b, 0x1f, 0x1c, 0x1d, 0x1c, 0x1f, 0x1e, 0x16, 0x1b, 
0x1c, 0x1d, 0x1b, 0x1f, 0x1b, 0x17, 0x1c, 0x18, 0x1d, 0x19, 0x1c, 0x1f, 0x20, 0x20, 0x1d, 0x1e, 0x1e, 0x1e, 0x1b, 0x1d, 0x22, 0x21, 0x22, 0x22, 0x20, 0x23, 0x22, 0x25, 0x24, 0x25, 0x20, 0x25, 
0x20, 0x22, 0x22, 0x22, 0x23, 0x21, 0x20, 0x23, 0x23, 0x20, 0x22, 0x25, 0x26, 0x21, 0x21, 0x23, 0x20, 0x1e, 0x23, 0x24, 0x22, 0x23, 0x21, 0x22, 0x24, 0x24, 0x26, 0x22, 0x23, 0x25, 0x21, 0x23, 
0x21, 0x21, 0x20, 0x20, 0x22, 0x21, 0x24, 0x20, 0x21, 0x21, 0x1f, 0x20, 0x20, 0x1f, 0x1c, 0x20, 0x1f, 0x1e, 0x20, 0x1e, 0x1f, 0x1c, 0x1f, 0x1e, 0x20, 0x22, 0x20, 0x1e, 0x1f, 0x1d, 0x1c, 0x1b, 
0x1b, 0x1e, 0x1d, 0x1d, 0x1a, 0x18, 0x1d, 0x1b, 0x1d, 0x1a, 0x19, 0x19, 0x19, 0x18, 0x1c, 0x1d, 0x1b, 0x1b, 0x1c, 0x1d, 0x1c, 0x1e, 0x21, 0x1e, 0x21, 0x1d, 0x1e, 0x20, 0x21, 0x1e, 0x21, 0x22, 
0x20, 0x22, 0x20, 0x22, 0x1f, 0x22, 0x21, 0x24, 0x23, 0x23, 0x24, 0x22, 0x24, 0x21, 0x27, 0x1f, 0x22, 0x20, 0x22, 0x23, 0x27, 0x27, 0x23, 0x20, 0x1f, 0x23, 0x21, 0x20, 0x22, 0x1d, 0x24, 0x21, 
0x1f, 0x21, 0x24, 0x24, 0x1f, 0x20, 0x21, 0x20, 0x1d, 0x1d, 0x21, 0x24, 0x20, 0x1f, 0x21, 0x1f, 0x1d, 0x21, 0x1e, 0x1f, 0x1d, 0x20, 0x1f, 0x1f, 0x21, 0x1d, 0x1d, 0x1f, 0x1e, 0x1d, 0x1f, 0x20, 
0x1c, 0x1d, 0x1e, 0x1c, 0x1e, 0x1b, 0x1e, 0x1b, 0x19, 0x1d, 0x1b, 0x1d, 0x1b, 0x1b, 0x1a, 0x1e, 0x1b, 0x1a, 0x1b, 0x1b, 0x1a, 0x1b, 0x1a, 0x1d, 0x1a, 0x1d, 0x1e, 0x1c, 0x24, 0x1f, 0x1d, 0x1e, 
0x1d, 0x1f, 0x1e, 0x1f, 0x20, 0x23, 0x23, 0x20, 0x20, 0x25, 0x23, 0x20, 0x1f, 0x22, 0x23, 0x24, 0x22, 0x23, 0x23, 0x21, 0x1f, 0x20, 0x22, 0x22, 0x24, 0x22, 0x25, 0x20, 0x1e, 0x20, 0x21, 0x23, 
0x20, 0x21, 0x21, 0x21, 0x1d, 0x23, 0x24, 0x1f, 0x20, 0x20, 0x1f, 0x21, 0x24, 0x20, 0x23, 0x20, 0x20, 0x21, 0x26, 0x1b, 0x20, 0x20, 0x21, 0x1e, 0x1e, 0x1d, 0x20, 0x1d, 0x1e, 0x1e, 0x1f, 0x1b, 
0x1d, 0x1e, 0x1d, 0x1d, 0x1c, 0x1d, 0x1b, 0x1f, 0x1b, 0x1c, 0x1f, 0x1e, 0x1a, 0x1c, 0x1e, 0x1b, 0x1b, 0x1a, 0x1d, 0x1a, 0x1a, 0x19, 0x1a, 0x1c, 0x1e, 0x1e, 0x1b, 0x1d, 0x19, 0x18, 0x18, 0x1e, 
0x1f, 0x1f, 0x1e, 0x1b, 0x1c, 0x1c, 0x1c, 0x21, 0x22, 0x22, 0x22, 0x1f, 0x22, 0x22, 0x24, 0x20, 0x22, 0x23, 0x22, 0x24, 0x22, 0x23, 0x24, 0x22, 0x22, 0x26, 0x1f, 0x20, 0x26, 0x1e, 0x1f, 0x21, 
0x1f, 0x20, 0x21, 0x20, 0x22, 0x22, 0x22, 0x21, 0x23, 0x24, 0x21, 0x1e, 0x1f, 0x23, 0x1e, 0x21, 0x21, 0x1f, 0x21, 0x1f, 0x1e, 0x21, 0x20, 0x23, 0x1d, 0x1c, 0x1f, 0x21, 0x22, 0x1e, 0x20, 0x20, 
0x1e, 0x20, 0x1f, 0x1c, 0x1e, 0x1e, 0x1c, 0x1d, 0x1f, 0x21, 0x1e, 0x1d, 0x1e, 0x1e, 0x1e, 0x1d, 0x20, 0x1a, 0x1e, 0x1c, 0x18, 0x1a, 0x1b, 0x1c, 0x1b, 0x1d, 0x1e, 0x1d, 0x1d, 0x1c, 0x18, 0x1a, 
0x18, 0x1a, 0x1b, 0x16, 0x1c, 0x18, 0x1d, 0x1e, 0x20, 0x1d, 0x1f, 0x20, 0x20, 0x21, 0x1f, 0x23, 0x1f, 0x1e, 0x23, 0x1f, 0x23, 0x1f, 0x23, 0x23, 0x22, 0x20, 0x22, 0x20, 0x20, 0x26, 0x22, 0x23, 
0x24, 0x24, 0x21, 0x22, 0x21, 0x23, 0x21, 0x23, 0x22, 0x20, 0x21, 0x22, 0x22, 0x1f, 0x21, 0x23, 0x22, 0x20, 0x22, 0x20, 0x22, 0x1f, 0x21, 0x24, 0x1f, 0x21, 0x1f, 0x1f, 0x22, 0x20, 0x20, 0x1f, 
0x1e, 0x1f, 0x21, 0x1c, 0x20, 0x1f, 0x22, 0x20, 0x1e, 0x1f, 0x1e, 0x1f, 0x1d, 0x1d, 0x1d, 0x1c, 0x1d, 0x1e, 0x1f, 0x1e, 0x1f, 0x1b, 0x1f, 0x1f, 0x1e, 0x21, 0x1a, 0x20, 0x1b, 0x1c, 0x1d, 0x19, 
0x1c, 0x1b, 0x1e, 0x19, 0x16, 0x19, 0x18, 0x17, 0x1c, 0x18, 0x1c, 0x1e, 0x1b, 0x1e, 0x1c, 0x1e, 0x1f, 0x20, 0x1f, 0x1e, 0x1c, 0x20, 0x1f, 0x1f, 0x21, 0x1e, 0x20, 0x21, 0x22, 0x1f, 0x25, 0x22, 
0x22, 0x23, 0x28, 0x20, 0x20, 0x22, 0x21, 0x21, 0x21, 0x21, 0x21, 0x25, 0x23, 0x21, 0x23, 0x25, 0x22, 0x1f, 0x25, 0x21, 0x20, 0x20, 0x21, 0x21, 0x23, 0x21, 0x26, 0x20, 0x22, 0x1d, 0x21, 0x23, 
0x22, 0x22, 0x20, 0x1f, 0x1f, 0x20, 0x1f, 0x20, 0x20, 0x20, 0x1d, 0x1f, 0x21, 0x1f, 0x22, 0x20, 0x1e, 0x1e, 0x22, 0x21, 0x20, 0x1e, 0x1f, 0x1f, 0x1d, 0x1d, 0x1d, 0x1f, 0x1c, 0x1e, 0x1e, 0x1c, 
0x1f, 0x1c, 0x21, 0x1e, 0x1f, 0x1b, 0x1e, 0x19, 0x1a, 0x19, 0x1b, 0x1d, 0x1b, 0x16, 0x1b, 0x19, 0x1a, 0x17, 0x1c, 0x1b, 0x1e, 0x23, 0x1e, 0x21, 0x1c, 0x1e, 0x22, 0x1f, 0x21, 0x22, 0x20, 0x22, 
0x21, 0x1e, 0x1f, 0x20, 0x21, 0x21, 0x22, 0x24, 0x22, 0x23, 0x24, 0x20, 0x25, 0x24, 0x22, 0x21, 0x20, 0x23, 0x1f, 0x21, 0x22, 0x21, 0x25, 0x20, 0x24, 0x1f, 0x23, 0x24, 0x20, 0x20, 0x21, 0x21, 
0x20, 0x22, 0x1d, 0x20, 0x21, 0x22, 0x22, 0x20, 0x26, 0x1f, 0x1f, 0x1d, 0x21, 0x24, 0x1c, 0x21, 0x22, 0x21, 0x1d, 0x20, 0x1c, 0x1f, 0x20, 0x1c, 0x1e, 0x22, 0x1c, 0x1d, 0x1f, 0x1e, 0x1f, 0x21, 
0x1d, 0x20, 0x1d, 0x1a, 0x1f, 0x1f, 0x1e, 0x1f, 0x1a, 0x1e, 0x1b, 0x1d, 0x19, 0x1b, 0x1c, 0x1c, 0x1a, 0x1c, 0x19, 0x1a, 0x18, 0x1a, 0x1c, 0x1a, 0x1b, 0x1d, 0x18, 0x1f, 0x1c, 0x1f, 0x21, 0x1c, 
0x21, 0x1e, 0x1d, 0x1d, 0x22, 0x22, 0x20, 0x1f, 0x23, 0x21, 0x22, 0x22, 0x1f, 0x25, 0x22, 0x21, 0x25, 0x21, 0x26, 0x24, 0x25, 0x1f, 0x24, 0x20, 0x21, 0x21, 0x1f, 0x21, 0x20, 0x20, 0x1e, 0x20, 
0x1e, 0x22, 0x1f, 0x23, 0x22, 0x22, 0x21, 0x20, 0x21, 0x1f, 0x21, 0x22, 0x1f, 0x1f, 0x1f, 0x1f, 0x1f, 0x1e, 0x1f, 0x1f, 0x20, 0x23, 0x20, 0x21, 0x1d, 0x1e, 0x1e, 0x20, 0x23, 0x21, 0x21, 0x1d, 
0x1d, 0x1f, 0x1b, 0x1d, 0x1b, 0x20, 0x1e, 0x1e, 0x1e, 0x1e, 0x1d, 0x1d, 0x1d, 0x1d, 0x1d, 0x1d, 0x1a, 0x1a, 0x1c, 0x1c, 0x1a, 0x1a, 0x1b, 0x19, 0x1c, 0x1f, 0x1b, 0x1b, 0x1c, 0x1c, 0x1a, 0x19, 
0x1c, 0x17, 0x1f, 0x20, 0x20, 0x1f, 0x20, 0x20, 0x1c, 0x1e, 0x1e, 0x21, 0x1d, 0x22, 0x20, 0x1f, 0x23, 0x20, 0x1e, 0x24, 0x25, 0x24, 0x26, 0x25, 0x21, 0x26, 0x21, 0x23, 0x23, 0x23, 0x21, 0x22, 
0x20, 0x23, 0x24, 0x25, 0x24, 0x20, 0x20, 0x22, 0x23, 0x20, 0x22, 0x23, 0x22, 0x20, 0x21, 0x23, 0x24, 0x21, 0x21, 0x1f, 0x1e, 0x20, 0x21, 0x23, 0x1f, 0x1e, 0x20, 0x1f, 0x23, 0x1e, 0x20, 0x22, 
0x1f, 0x1d, 0x1c, 0x20, 0x1f, 0x1f, 0x1e, 0x1f, 0x1a, 0x1e, 0x20, 0x1e, 0x1d, 0x1e, 0x1d, 0x1b, 0x1f, 0x1d, 0x1e, 0x21, 0x1d, 0x1c, 0x1b, 0x1c, 0x19, 0x1b, 0x1c, 0x1b, 0x18, 0x1b, 0x18, 0x17, 
0x1b, 0x1b, 0x17, 0x20, 0x19, 0x1a, 0x15, 0x1b, 0x1b, 0x1e, 0x1d, 0x1e, 0x1e, 0x1c, 0x20, 0x22, 0x20, 0x21, 0x1f, 0x1e, 0x21, 0x20, 0x22, 0x23, 0x22, 0x24, 0x25, 0x28, 0x23, 0x23, 0x22, 0x20, 
0x22, 0x22, 0x22, 0x1f, 0x24, 0x20, 0x23, 0x23, 0x22, 0x21, 0x1f, 0x22, 0x23, 0x21, 0x20, 0x24, 0x23, 0x21, 0x23, 0x22, 0x21, 0x1e, 0x23, 0x25, 0x20, 0x1e, 0x23, 0x20, 0x1e, 0x1e, 0x22, 0x1d, 
0x1d, 0x21, 0x21, 0x1e, 0x20, 0x20, 0x20, 0x1e, 0x1f, 0x1f, 0x1f, 0x20, 0x21, 0x1f, 0x1e, 0x1e, 0x1f, 0x1d, 0x1e, 0x1e, 0x1d, 0x1f, 0x22, 0x1b, 0x1e, 0x20, 0x1e, 0x1a, 0x1f, 0x18, 0x1b, 0x1a, 
0x1d, 0x1e, 0x1b, 0x1e, 0x1d, 0x1d, 0x1c, 0x18, 0x1c, 0x18, 0x1b, 0x1a, 0x1b, 0x1a, 0x1c, 0x17, 0x1f, 0x1e, 0x1f, 0x1d, 0x21, 0x21, 0x20, 0x1e, 0x20, 0x21, 0x23, 0x20, 0x22, 0x23, 0x24, 0x21, 
0x24, 0x23, 0x1f, 0x1f, 0x26, 0x22, 0x22, 0x23, 0x23, 0x22, 0x20, 0x23, 0x24, 0x22, 0x20, 0x20, 0x24, 0x23, 0x21, 0x21, 0x23, 0x25, 0x22, 0x1e, 0x21, 0x20, 0x22, 0x22, 0x22, 0x1d, 0x25, 0x21, 
0x22, 0x24, 0x20, 0x1f, 0x1c, 0x22, 0x1d, 0x20, 0x20, 0x21, 0x20, 0x1f, 0x1e, 0x1c, 0x20, 0x1e, 0x1f, 0x1e, 0x1f, 0x20, 0x23, 0x1d, 0x1d, 0x1c, 0x1a, 0x1d, 0x1e, 0x1e, 0x1e, 0x1f, 0x1d, 0x1c, 
0x1e, 0x1c, 0x1d, 0x1e, 0x19, 0x1e, 0x21, 0x1a, 0x1a, 0x1d, 0x18, 0x19, 0x1d, 0x1c, 0x1c, 0x1b, 0x1b, 0x1c, 0x17, 0x1b, 0x1c, 0x1a, 0x1b, 0x1b, 0x1f, 0x20, 0x1d, 0x1f, 0x1e, 0x1c, 0x20, 0x20, 
0x1f, 0x21, 0x1f, 0x1f, 0x24, 0x23, 0x21, 0x21, 0x23, 0x1f, 0x21, 0x22, 0x22, 0x23, 0x22, 0x25, 0x24, 0x21, 0x25, 0x1e, 0x23, 0x22, 0x1e, 0x1f, 0x22, 0x21, 0x20, 0x20, 0x20, 0x25, 0x21, 0x21, 
0x23, 0x21, 0x20, 0x1e, 0x23, 0x1c, 0x24, 0x21, 0x1f, 0x1e, 0x21, 0x21, 0x24, 0x24, 0x1c, 0x1f, 0x21, 0x1e, 0x1e, 0x21, 0x1c, 0x20, 0x20, 0x1f, 0x21, 0x1f, 0x1f, 0x1c, 0x24, 0x1d, 0x1d, 0x1e, 
0x1d, 0x1c, 0x1d, 0x1e, 0x1f, 0x1b, 0x1e, 0x1c, 0x1e, 0x1d, 0x1c, 0x19, 0x1d, 0x1c, 0x1d, 0x1b, 0x1b, 0x1c, 0x1c, 0x1a, 0x1f, 0x19, 0x1b, 0x1a, 0x18, 0x19, 0x19, 0x1a, 0x1c, 0x19, 0x1f, 0x1e, 
0x1d, 0x23, 0x21, 0x1e, 0x21, 0x21, 0x23, 0x22, 0x24, 0x22, 0x24, 0x23, 0x21, 0x24, 0x24, 0x23, 0x24, 0x23, 0x24, 0x22, 0x21, 0x23, 0x25, 0x24, 0x21, 0x24, 0x27, 0x25, 0x24, 0x22, 0x24, 0x23, 
0x1f, 0x21, 0x25, 0x23, 0x20, 0x23, 0x20, 0x24, 0x24, 0x21, 0x1f, 0x24, 0x20, 0x23, 0x22, 0x23, 0x24, 0x23, 0x20, 0x23, 0x21, 0x21, 0x23, 0x22, 0x22, 0x1f, 0x22, 0x22, 0x21, 0x20, 0x1d, 0x22, 
0x1f, 0x1f, 0x21, 0x1e, 0x1e, 0x21, 0x1d, 0x1f, 0x1e, 0x1f, 0x1f, 0x1d, 0x1e, 0x1d, 0x1e, 0x20, 0x1c, 0x1b, 0x1c, 0x1d, 0x1d, 0x1c, 0x19, 0x1d, 0x1d, 0x18, 0x1b, 0x1a, 0x1d, 0x18, 0x1a, 0x1e, 
0x1a, 0x1d, 0x1a, 0x1e, 0x1b, 0x1e, 0x1e, 0x1f, 0x1e, 0x1c, 0x1f, 0x21, 0x1f, 0x22, 0x21, 0x23, 0x26, 0x21, 0x20, 0x22, 0x21, 0x21, 0x25, 0x23, 0x25, 0x23, 0x23, 0x22, 0x25, 0x23, 0x24, 0x23, 
0x23, 0x21, 0x21, 0x1e, 0x20, 0x22, 0x20, 0x21, 0x21, 0x23, 0x23, 0x20, 0x21, 0x24, 0x23, 0x23, 0x21, 0x1e, 0x21, 0x22, 0x1f, 0x23, 0x20, 0x1f, 0x1e, 0x22, 0x23, 0x20, 0x1f, 0x1f, 0x23, 0x21, 
0x21, 0x1f, 0x21, 0x21, 0x21, 0x24, 0x1f, 0x22, 0x1f, 0x1e, 0x1e, 0x1e, 0x1f, 0x20, 0x1e, 0x1e, 0x1f, 0x1e, 0x20, 0x1b, 0x1b, 0x1f, 0x1d, 0x1b, 0x1a, 0x1a, 0x19, 0x1c, 0x1a, 0x1c, 0x1d, 0x1c, 
0x19, 0x1b, 0x1b, 0x1a, 0x17, 0x18, 0x19, 0x19, 0x1d, 0x1e, 0x19, 0x19, 
}, .response_length = 7};
//static const Packet EGIS0575_CALIBRATION_PACKET_2 = {.length = 5356, .sequence = (unsigned char[]){}, .response_length = 7};


static const Packet EGIS0575_POST_CALIBRATION_PACKETS[] = {
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x40, 0xec}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x0c, 0x22}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x0b, 0x03}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x0a, 0xfc}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x40, 0xfc}, .response_length = 7},
  {.length = 18, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x63, 0x09, 0x0b, 0x83, 0x24, 0x00, 0x44, 0x0f, 0x08, 0x20, 0x20, 0x01, 0x05, 0x12}, .response_length = 18},
  {.length = 13, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x63, 0x26, 0x06, 0x06, 0x60, 0x06, 0x05, 0x2f, 0x06}, .response_length = 13},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x23, 0x00}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x24, 0x33}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x20, 0x00}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x21, 0x66}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x00, 0x66}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x01, 0x66}, .response_length = 7},
  {.length = 9, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x63, 0x2c, 0x02, 0x00, 0x57}, .response_length = 9},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x2d, 0x02}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x62, 0x67, 0x03}, .response_length = 10},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x0f, 0x03}, .response_length = 7},
  {.length = 9, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x63, 0x2c, 0x02, 0x00, 0x13}, .response_length = 9},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x00, 0x02}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x64, 0x14, 0xec}, .response_length = 5356} // to post repeat
};

static const Packet EGIS0575_PRE_FIRST_IMAGE_PACKETS[] = {
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x40, 0x06}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x0a, 0xf4}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x0c, 0x44}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x40, 0x00}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x40, 0x00}, .response_length = 7},
  {.length = 9, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x71, 0x02, 0x02, 0x01, 0x0c}, .response_length = 9},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x0c, 0x22}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x0b, 0x03}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x0a, 0xfc}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x00, 0xfc}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x01, 0xfc}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x40, 0xfc}, .response_length = 7},
  {.length = 18, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x63, 0x09, 0x0b, 0x83, 0x24, 0x00, 0x44, 0x0f, 0x08, 0x20, 0x20, 0x01, 0x05, 0x12}, .response_length = 18},
  {.length = 13, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x63, 0x26, 0x06, 0x06, 0x60, 0x06, 0x05, 0x2f, 0x06}, .response_length = 13},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x23, 0x00}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x24, 0x33}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x20, 0x00}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x21, 0x66}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x00, 0x66}, .response_length = 7},
  {.length = 9, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x63, 0x2c, 0x02, 0x00, 0x57}, .response_length = 9},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x2d, 0x02}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x62, 0x67, 0x03}, .response_length = 10},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x0f, 0x03}, .response_length = 7},
  {.length = 9, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x63, 0x2c, 0x02, 0x00, 0x13}, .response_length = 9},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x00, 0x02}, .response_length = 7},
};
static const Packet EGIS0575_REPEAT_PACKETS[] = {
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x2d, 0x20}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x00, 0x20}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x01, 0x20}, .response_length = 7},
  {.length = 9, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x63, 0x2c, 0x02, 0x00, 0x57}, .response_length = 9},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x2d, 0x02}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x62, 0x67, 0x03}, .response_length = 10},
  {.length = 9, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x63, 0x2c, 0x02, 0x00, 0x13}, .response_length = 9},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x00, 0x02}, .response_length = 7},
};

static const Packet EGIS0575_POST_REPEAT_PACKETS[] = {
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x2d, 0x20}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x60, 0x40, 0x20}, .response_length = 7},
  {.length = 13, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x63, 0x26, 0x06, 0x06, 0x60, 0x06, 0x05, 0x2f, 0x06}, .response_length = 13},
  {.length = 18, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x63, 0x09, 0x0b, 0x83, 0xf4, 0x03, 0x44, 0x03, 0x0b, 0x14, 0x20, 0x01, 0x0a, 0x72}, .response_length = 18},
  {.length = 9, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x63, 0x01, 0x02, 0x0c, 0x03}, .response_length = 9},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x0c, 0x22}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x0b, 0x03}, .response_length = 7},
  {.length = 7, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x61, 0x0a, 0xfc}, .response_length = 7},
  {.length = 13, .sequence = (unsigned char[]){0x45, 0x47, 0x49, 0x53, 0x71, 0x45, 0x06, 0x00, 0xb9, 0x87, 0x13, 0x00, 0x03}, .response_length = 13},
};
